using CoreGraphics;
using Syncfusion.SfDataGrid;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using UIKit;

namespace GroupDemo
{
    public class MyViewController : UIViewController
    {
        SfDataGrid dataGrid;
        IncrementalLoadingViewModel viewModel;
        public MyViewController()
        {
            viewModel = new IncrementalLoadingViewModel();
            dataGrid = new SfDataGrid();
            dataGrid.ItemsSource = viewModel.GridSource;
            dataGrid.AutoGenerateColumns = true;
            dataGrid.ColumnSizer = ColumnSizer.None;

			dataGrid.QueryRowHeight += Grid_QueryRowHeight;
          //  dataGrid.GridTapped += async(s, e) => { await Task.Delay(500); viewModel.GridSource.Add(viewModel.orderInfoReporsitory.GenerateOrder(999)); };
            View.AddSubview(dataGrid);
            View.AddSubview(viewModel.LoaderBorder);

			dataGrid.TranslatesAutoresizingMaskIntoConstraints = false;
			View.AddConstraint(NSLayoutConstraint.Create(dataGrid, NSLayoutAttribute.Top, NSLayoutRelation.Equal, View, NSLayoutAttribute.Top, 1, 30));
			View.AddConstraint(NSLayoutConstraint.Create(dataGrid, NSLayoutAttribute.Left, NSLayoutRelation.Equal, View, NSLayoutAttribute.Left, 1, 0));
			View.AddConstraint(NSLayoutConstraint.Create(dataGrid, NSLayoutAttribute.Bottom, NSLayoutRelation.Equal, View, NSLayoutAttribute.Bottom, 1, 0));
			View.AddConstraint(NSLayoutConstraint.Create(dataGrid, NSLayoutAttribute.Right, NSLayoutRelation.Equal, View, NSLayoutAttribute.Right, 1, 0));

        }

		void Grid_QueryRowHeight(object sender, QueryRowHeightEventArgs e)
		{
			if (e.RowIndex > 0)
			{
				double height = SfDataGridHelpers.GetRowHeight(dataGrid, e.RowIndex);
				e.Height = height;
				e.Handled = true;

			}
		}

        public override void ViewDidLayoutSubviews()
        {
            base.ViewDidLayoutSubviews();
            //dataGrid.Frame = new CoreGraphics.CGRect(0, 20, this.View.Frame.Width, this.View.Frame.Height - 20);
            viewModel.LoaderBorder.Frame = new CGRect(0, this.View.Frame.Height - 60, this.View.Frame.Width, 70);
            viewModel.LoaderIndicator.Frame = new CGRect(50, 25, 20, 20);
            viewModel.LoaderLable.Frame = new CGRect(80, 0, this.View.Frame.Width, 70);
            viewModel.LoaderLable.TextColor = UIColor.White;
        }
    }

}